/*
 * Copyright (c) 2015 by inovat, innovative systeme - verkehr - tunnel - technik, Dipl.-Ing. H. C. Kniss
 *
 * This file is part of de.bsvrz.kex.tls.osi7.conversion.KommentareFg001
 *
 * de.bsvrz.kex.tls.osi7.conversion.KommentareFg001 is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  de.bsvrz.kex.tls.osi7.conversion.KommentareFg001 is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with de.bsvrz.kex.tls.osi7.conversion.KommentareFg001.  If not, see <http://www.gnu.org/licenses/>.
 *
 *  Diese Datei ist Teil von de.bsvrz.kex.tls.osi7.conversion.KommentareFg001.
 *
 *  de.bsvrz.kex.tls.osi7.conversion.KommentareFg001 ist Freie Software: Sie können es unter den Bedingungen
 *  der GNU General Public License, wie von der Free Software Foundation,
 *  Version 3 der Lizenz oder (nach Ihrer Wahl) jeder späteren
 *  veröffentlichten Version, weiterverbreiten und/oder modifizieren.
 *
 *  de.bsvrz.kex.tls.osi7.conversion.KommentareFg001 wird in der Hoffnung, dass es nützlich sein wird, aber
 *  OHNE JEDE GEWÄHRLEISTUNG, bereitgestellt; sogar ohne die implizite
 *  Gewährleistung der MARKTFÄHIGKEIT oder EIGNUNG FÜR EINEN BESTIMMTEN ZWECK.
 *  Siehe die GNU General Public License für weitere Details.
 *
 *  Sie sollten eine Kopie der GNU General Public License zusammen mit diesem
 *  Programm erhalten haben. Wenn nicht, siehe <http://www.gnu.org/licenses/>.
 *
 * Contact Information:
 * inovat, Dipl.-Ing. H. C. Kniss
 * An der Krautwiese 37
 * D-53783 Eitorf
 * +49 (0)2243 8464 193
 * info@inovat.de
 * www.inovat.de
 */

package de.bsvrz.kex.tls.osi7.conversion;

/**
 * <p/>
 * Created by Kappich+Kniß Systemberatung Aachen (K2S) (20.11.2003/21:13:24)
 *
 * @author Dipl.-Ing. Hans Christian Kniß (HCK)
 * @version $Revision$ / $Date$ / ($Author$)
 */

class KommentareFg001 {
// ------------------------------------------------------------------------
// SONSTIGE METHODEN
// ------------------------------------------------------------------------

	/**
	 * FG 4 : Typ: 1 Id: 1 und ID: 33 Name: DE-Fehlermeldung (Antwort).
	 * <p/>
	 * Inhalt Byte: Fehlercode:
	 * <pre>
	 *    7           6           5           4           3        2        1        0
	 *    reserviert  reserviert  reserviert  reserviert  Passiv   Proj-F   Stö/SM   Stö/EAK
	 * <p/>
	 * Bit 0:    Stö/EAK =  0: Keine Störung / vom E/A-Konzentrator erkannt
	 *                      1: Störung / vom E/A-Konzentrator erkannt
	 * Bit 1:    Stö/SM =   0: Keine Störung / vom SM erkannt
	 *                      1: Störung / vom SM erkannt
	 * Bit 2:    Proj-F =   0: Projektierungsdaten für diesen Kanal sind gültig
	 *                      1: Projektierungsdaten für diesen Kanal enthalten ungültige Werte
	 * Bit 3:    Passiv =   0: Der Kanal ist nicht passiviert
	 *                      1: Der Kanal ist passiviert
	 * Bit 4..7:        =   0: reserviert
	 * <p/>
	 * Die Bits 0 und 1 werden nur einzeln gesetzt, d.h. es darf nur ein Bit den Zustand 1 annehmen.
	 * </pre>
	 */

	void Fg004Typ001Id001Id033() {

	}

	/**
	 * FG 4 : Typ: 2 Id: 1 und Id: 33 Name: Nicht darstellbare WVZ (Antwort).
	 * <p/>
	 * <p/>
	 * <pre>
	 * Position         Bezeichnung                                 Erläuterung
	 * Byte 1           Länge DE-Block                              Länge des folgenden DE-Blocks [3 + n ]
	 * Byte 2           Daten-Endgeräte-Kanal                       [ 1.. 254 ]
	 * Byte 3           Typ der DE-Daten                            [ 2 ]
	 * Byte 4           Anzahl Code-Bytes                           Anzahl nicht mehr darstellbarer WVZ
	 * Byte 5           1. WVZ-Code                                 1. nicht mehr darstellb. Zeichen (lt. Anh. 7, Kap.1)
	 * Byte .. n.       WVZ-Code                                    n. nicht mehr darstellb. Zeichen (lt. Anh. 7, Kap. 1)
	 * </pre>
	 */

	void Fg004Typ002Id001Id033() {

	}

	/**
	 * FG 4 : Typ: 3 Id: 1 Name: Defekte Lampen (Antwort).
	 * <p/>
	 * <p/>
	 * <pre>
	 * Position         Bezeichnung                               Erläuterung
	 * Byte 1           Länge DE-Block                            Länge des folgenden DE-Blocks [3 + n ]
	 * Byte 2           Daten-Endgeräte-Kanal (DE)                [ 1..254 ]
	 * Byte 3           Typ der DE-Daten                          [ 3 ]
	 * Byte 4           Anzahl Lampenpaare
	 * Byte 5           1. Lampen-Statusbyte                      Enthält die Gut/Schlecht-Aussage von 8 Lampen
	 * Byte .. n.       Lampen-Statusbyte                         Enthält die Gut/Schlecht-Aussage von 8 Lampen
	 * </pre>
	 * Inhalt 1. Lampen-Statusbyte
	 * <pre>
	 *    7        6        5        4        3        2        1        0
	 *    NL 4     HL 4     NL 3     HL 3     NL 2     HL 2     NL 1     HL 1
	 * </pre>
	 * Bits 0,2,4,6 :    Hauptlampen 1 bis 4,    (0 = OK, 1 = defekt)<br> Bits 1,3,5,7 :    Nebenlampen 1 bis 4,    (0 =
	 * OK, 1 = defekt)<br> <br> Die weiteren Lampen-Statusbytes enthalten die Lampenpaare in entsprechend aufsteigender
	 * Folge.<br>
	 */

	void Fg004Typ003Id001() {

	}

	/**
	 * FG 4 : Typ: 4 Id: 1 und Id: 33 Name: Gestörte Textpositionen (Antwort).
	 * <p/>
	 * <p/>
	 * <pre>
	 * Position         Bezeichnung                                         Erläuterung
	 * Byte 1           Länge DE-Block                                      Länge des folgenden DE-Blocks [3 + n ]
	 * Byte 2           Daten-Endgeräte-Kanal (DE)                          [ 1..254 ]
	 * Byte 3           Typ der DE-Daten                                    [ 4]
	 * Byte 4           Anzahl ausgefallener Textpositionen                 [ 0..213 ]
	 * Byte 5           1. gestörte Textposition Position der Textanzeige   [ 1..213 ]
	 * Byte ..          n. gestörte Textposition Position der Textanzeige   [ 1..213 ]
	 * </pre>
	 */

	void Fg004Typ004Id001Id033() {

	}

	/**
	 * FG 4 : Typ: 14 Id: 1 und Id: 33 Name: Ergänzende DE-Fehlermeldung (Antwort).
	 * <p/>
	 * <p/>
	 * <pre>
	 * Position         Bezeichnung                             Erläuterung
	 * Byte 1           Länge DE-Block                          [ 9..29 ]
	 * Byte 2           Daten-Endgeräte-Kanal                   [ 1..254 ]
	 * Byte 3           Typ der DE-Daten                        [ 14 ]
	 * Byte 4           Herstellercode                          (s. Anh. 7, Kap. 2)
	 * Byte 5           Anzahl TLS - Fehlerbytes                [ 4 ]
	 * Byte 6           TLS - Fehlerbyte 1                      Codierung siehe unten
	 * Byte 7           TLS - Fehlerbyte 2                      Codierung siehe unten
	 * Byte 8           TLS - Fehlerbyte 3                      Codierung siehe unten
	 * Byte 9           TLS - Fehlerbyte 4                      Codierung siehe unten
	 * Byte 10          Anzahl Hersteller Fehlerbytes           [ 0..20 ]
	 * Byte 11          Hersteller-Fehlerbyte 1                 herstellerspez. Codierung
	 * Byte..           Hersteller-Fehlerbyte n                 herstellerspez. Codierung
	 * </pre>
	 * <br> Inhalt TLS-Fehlerbytes:<br> Die Fehlerbytes sind bitweise codiert. Jedes Bit definiert einen bestimmten Fehler,
	 * wobei das Bit gleich 1 gesetzt ist.<br> Es können auch mehrere Bit gleichzeitig gesetzt werden. Der Inhalt der
	 * Fehlerbytes ist optimal. D.h. bei einer Realisierung dieses Telegrammtyps müssen vom Hersteller nicht alle in der
	 * Tabelle definierten Fehlercodes erfüllt werden. Für spätere Definitionen reservierte Bits bzw. nicht verwendete Bits
	 * sind gleich Null zu setzen.<br>
	 * <pre>
	 *         Bit 7      Bit 6       Bit 5       Bit 4          Bit 3         Bit 2       Bit 1       Bit 0
	 * Byte 1  Reserve    Reserve     RNR am      Lokalbus       Reserve       Reserve     Reserve     Teilstörung
	 *                                Lokalbus1   ausgefallen
	 * Byte 2  Reserve    Reserve     Fehler in   Fehler in      WZG Ver-      WZG         RNR am      Subbus
	 *                                Wechseltext-Prismenan-     sorgungs-     defekt      Subbus      ausgefallen
	 *                                steuerung   steuerung      spannung
	 *                                                           unter/über-
	 *                                                           schritten
	 * Byte 3  Reserve    Reserve     Reserve     Reserve        Reserve       Reserve     Reserve     Reserve
	 * Byte 4  Reserve    Reserve     Reserve     Reserve        Reserve       Reserve     Reserve     Reserve
	 * 1) nur in Verbindung mit Stö/SM=1 im Byte 4 der DE-Block-Struktur im Typ 1
	 * <p/>
	 * </pre>
	 */

	void Fg004Typ014Id001Id033() {

	}

	/**
	 * FG 4 : Typ: 16 Id: 2 Name: Negative Quittung (Antwort).
	 * <p/>
	 * <p/>
	 * <pre>
	 * Position         Bezeichnung                             Erläuterung
	 * Byte 1           Länge DE-Block                          Länge des folgenden DE-Blocks [ 4 ]
	 * Byte 2           Daten-Endgeräte-Kanal                   [ 1..254 ]
	 * Byte 3           Typ der DE-Daten                        [ 16 ]
	 * Byte 4           Fehlerursache                           siehe unten
	 * Byte 5           Herstellercode                          siehe Liste in Anhang 7, Kap. 2
	 * </pre>
	 * Inhalt Byte: Fehlerursache unter FG 4:
	 * <pre>
	 *        0:   sonstige Fehlerursache
	 *        1:   unbekannte oder nicht auswertbare ID
	 *        2:   unbekannter oder nicht auswertbarer Typ
	 *        3:   reserviert für spätere Definition
	 *        4:   Stellcode auf diesem WZG oder AQ nicht vorhanden
	 *        5:   Stellcode wegen defekter Anzeige (Lampen, Prisma oder Rollo) nicht schaltbar
	 *        6:   Stellcode wegen sonstiger Hardwarestörungen nicht schaltbar
	 *        7:   Helligkeitswert nicht einstellbar
	 *        8:   Keine automatische Helligkeitssteuerung möglich
	 *        9:   Betriebsart unbekannt bzw. nicht einstellbar
	 *       10:   Befehl bzw. Programm in dieser Betriebsart nicht ausführbar
	 *       11:   Nachricht nicht bearbeitbar, da Projektierungsdaten fehlerhaft sind
	 *       12:   Pufferinhalt nicht verfügbar
	 *       13:   Prismencode nicht zulässig (z.B. Stellung 4 für Dreikantprisma oder Blinkercode für Prisma)
	 *       14:   Funktionsbyte unzulässig (z.B. Blinkfunktion nicht vorhanden)
	 *       15:   Kanal passiviert
	 *       16:   Verriegelungsmatrix verletzt (für Stellzustände eines AQ oder Programm einer KBA)
	 *       17:   Anzahl Prismen/Anzeigen oder DEs im Telegramm stimmt nicht mit vorhandener Anzahl überein
	 *       18:   Kein freier Speicherplatz zum Ablegen von Programmdaten vorhanden
	 *       19:   Wechseltext nicht darstellbar, da zu lang
	 *       20:   Wechseltext enthält nicht darstellbare Zeichen
	 *       21:   falsches Anzeigeprinzip
	 *  22 - 31:   reserviert für spätere Definitionen
	 *       32:   vorheriges Programm noch nicht abgeschlossen
	 *       33:   Betriebsartenwechsel nicht abgeschlossen
	 *       34:   Betriebsart nicht eindeutig feststellbar
	 *       35:   Helligkeitsumschaltung noch nicht abgeschlossen
	 *       36:   Helligkeit nicht eindeutig feststellbar
	 *       37:   Keine Programmdaten verfügbar
	 *       38:   Übergang zum Signalprogramm nicht definiert
	 *       39:   Übergang zum Grundprogramm nicht definiert
	 *       40:   Programmdaten unvollständig
	 *       41:   Stellcode-Vorrat nicht änderbar
	 *       42:   Stellcode-Definition nicht änderbar
	 *       43:   Unzulässiger Stellcode
	 *       44:   Kurzversion mit diesem Stellcode nicht zulässig
	 *       45:   Stellcode bei Steuerungsprinzip 1 nicht zulässig
	 *       46:   Langversion nicht zulässig
	 *       47:   Löschen benutzter Stellcodes nicht zulässig
	 *       48:   Programmdefinition enthält undefinierten Stellcode
	 *  49..127:   reserviert für spätere Definitionen
	 * 128..255:   frei für herstellerdefinierte Ursachencodes
	 * </pre>
	 * Inhalt Byte Herstellercode<br> Der Herstellercode ist ein für jeden Hersteller eindeutig zugeordneter Code, der der
	 * Zentrale die Zuordnung der Nachrichten erleichtern soll.<br>
	 */

	void Fg004Typ016Id002() {

	}

	/**
	 * FG 4 : Typ: 17 Id: 2 Name: Betriebsart (Antwort).
	 * <p/>
	 * <p/>
	 * <pre>
	 * Position         Bezeichnung                                    Erläuterung
	 * Byte 1           Länge DE-Block                                 Länge des folgenden DE-Blocks [ 3 ]
	 * Byte 2           Daten-Endgeräte-Kanal (DE)                     [193..222, 223, (255)1]
	 * Byte 3           Typ der DE-Daten                               [ 17 ]
	 * Byte 4           Betriebsart                                    siehe unten
	 * </pre>
	 * 1) siehe Seite A6.1.1 - 3, Kapitel 1.4<br> Inhalt Byte: Betriebsart:<br>
	 * <pre>
	 *        0: frei
	 *        1: Normalbetrieb
	 *        2: Blindbetrieb
	 *        3: Handbetrieb
	 *        4: Autarker Betrieb
	 *        5: Testbetrieb
	 *        6: Notbetrieb
	 *   7..255: noch nicht definiert
	 * </pre>
	 */

	void Fg004Typ017Id001Id033() {

	}

	/**
	 * FG 4 : Typ: 20 Id: 2 Name: Abruf Pufferinhalt (Abruf).
	 * <p/>
	 * <pre>
	 * Position         Bezeichnung                                    Erläuterung
	 * Byte 1           Länge DE-Block                                 [ 5 ]
	 * Byte 2           Daten-Endgeräte-Kanal (DE)                     [ 193..222, 223,(2551) ]
	 * Byte 3           Typ der DE-Daten                               [ 20 ]
	 * Byte 4           Erste Folgenummer (low Byte)                   [ 0, 1...65535 ]
	 * Byte 5           Erste Folgenummer (high Byte)
	 * Byte 6           Anzahl angeforderter Nachrichten               [ 1...255 ]
	 * </pre>
	 * 1) siehe Seite A6.1.1 - 3, Kapitel 1.4<br> Inhalt Byte Anzahl angeforderter Nachrichten:<br> Gibt die Anzahl der zu
	 * übertragenden Nachrichten an. Dabei wird ab der durch die Folgenummer festgelegten Nachricht in Richtung der
	 * aktuellen Nachricht gezählt.<br> Die älteste der geforderten Nachrichten wird auch zuerst übertragen. Ist die
	 * Folgenummer = 0, wird die entsprechende Anzahl der aktuellsten Nachrichten übertragen. Stehen zum Beispiel die
	 * Telegramm 1..35 im Speicher, wobei 35 die aktuelle Nachricht ist, werden beim Abruf Folgenummer = 0, Anzahl
	 * geforderter Nachrichten = 3 die Nachrichten 33 bis 35 übertragen.<br>
	 */

	void Fg004Typ020Id002() {

	}

	/**
	 * FG 4 : Typ: 21 Id: 3 Name: Abruf Codedefinition (Abruf).
	 * <p/>
	 * <p/>
	 * <pre>
	 * Position         Bezeichnung                                    Erläuterung
	 * Byte 1           Länge DE-Block                                 [ 3 ]
	 * Byte 2           Daten-Endgeräte-Kanal (DE)                     [ 1..254, 255 ]
	 * Byte 3           Typ der DE-Daten                               [ 21 ]
	 * Byte 4           Stellcode                                      [ 1..254]
	 * </pre>
	 * Inhalt Byte: Stellcode:<br> Enthält den Stellcode, dessen Definition angefordert wird.<br>
	 */

	void Fg004Typ021Id003() {

	}

	/** FG 4 : Typ: 29 Id: 2 Name: Kanalsteuerung (Abruf / Antwort). */

	void Fg004Typ029Id002() {

	}

	/** FG 4 : Typ: 30 Id: 1  Name: Zeitstempel (Antwort). */

	void Fg004Typ030Id002() {

	}

	/**
	 * FG 4 : Typ: 31 Id: 1,2,5 und Id: 33,34, 33 und Id: 3 und Id: 35  Name: Zeitstempel mit Folgenummern (Antwort).
	 * <p/>
	 * <p/>
	 * <pre>
	 * Position         Bezeichnung                                    Erläuterung
	 * Byte 1           Länge DE-Block                                 Länge des folgenden DE-Blocks [ 8 ]
	 * Byte 2           Daten-Endgeräte-Kanal                          [ 255 ]
	 * Byte 3           Typ der DE-Daten                               [ 31 ]
	 * Byte 4           Zeitbereich / Stunde                           [ 0/1 * 128 + 0..23 ]
	 * Byte 5           Minute                                         [ 0..59 ]
	 * Byte 6           Sekunde                                        [ 0..59 ]
	 * Byte 7           Tag                                            [ 1..31 ]
	 * Byte 8           Folgenummer (low Byte)                         [ 1...65535, die 0 wird nicht verwendet ]
	 * Byte 9           Folgenummer (high Byte)
	 * </pre>
	 * Inhalt Byte Zeitbereich/Stunde<br>
	 * <pre>
	 * Bit 0...6:    Angabe der Stunde, binär codiert
	 * Bit 7 = 0:    Normalzeit (MEZ)
	 * Bit 7 = 1:    Sommerzeit (MESZ)
	 * </pre>
	 */

	void Fg004Typ031Id001Id002Id005Id033Id034Id037Id003Id035() {

	}

	/**
	 * FG 4 : Typ: 32 Id: 3 Name: WVZ-Grundeinstellung (Abruf / Antwort).
	 * <p/>
	 * <p/>
	 * <pre>
	 * Position         Bezeichnung                                    Erläuterung
	 * Byte 1           Länge DE-Block                                 Länge des folgenden DE-Blocks [ 4 ]
	 * Byte 2           Daten-Endgeräte-Kanal (DE)                     [ 1..254, 255 ]
	 * Byte 3           Typ der DE-Daten                               [ 32 ]
	 * Byte 4           Stellzustand: WVZ-Code                         anzuzeigendes WVZ
	 * Byte 5           Funktionsbyte                                   Ein / Aus / Blinken
	 * </pre>
	 * Inhalt Byte: Stellzustand:<br> Codierung von Verkehrszeichen: (WVZ-Code): Siehe Anhang 7, Kapitel 1.<br> Wird der
	 * WVZ-Code 255 ausgewählt, so bleibt der zuletzt geschaltete Stellzustand im Autarkbetrieb bestehen.<br> <br> Inhalt
	 * Funktionsbyte:<br>
	 * <pre>
	 *    7        6        5        4        3        2        1        0
	 *               Blinkzeit                            Funktion
	 * Bit 0..3:     Funktion:
	 *               0 = ausschalten
	 *               1 = einschalten
	 *               2 = blinken (Die Einstellung "WVZ blinkend" ist eine optionale Eigenschaft.)
	 *               3-15 reserviert
	 * <p/>
	 * Bit 4..7:     Blinkzeit in 200 ms (1..3 s)
	 *               Die Blinkzeit ist die gesamte Periodendauer, d.h. die Summe aus Ein- und Auszeit. Das Verhältnis Ein-
	 *               /Auszeit wird nach Vorgabe des Anlagenbetreibers am WZG eingestellt.
	 *               Die Koordination der Blinkzeiten verschiedener WVZ ist Aufgabe der Zentrale.
	 * </pre>
	 */

	void Fg004Typ032Id003() {

	}

	/**
	 * FG 4 : Typ: 33 Id: 3 und Id: 31 Name: Grundeinstellung (Abruf / Antwort).
	 * <p/>
	 * <p/>
	 * <pre>
	 * Position         Bezeichnung                              Erläuterung
	 * Byte 1           Länge DE-Block                           Länge des folgenden DE-Blocks [5 |6+f*n]
	 * Byte 2           Daten-Endgeräte-Kanal (DE)               [ 1..254 ]
	 * Byte 3           Typ der DE-Daten                         [ 33 ]
	 * Byte 4           Anzeigeprinzip                           siehe unten
	 * Byte 5           Stellcode der Grundeinstellung           [0, 1..254, 255]siehe unten
	 * Byte 6           Funktionsbyte                            siehe unten, vgl Kap. 6.2.18
	 * Byte 7           n : Anzahl Komponenten 1             [213 | 106] siehe unten
	 * f Bytes...       Grundeinstellung der 1.Komponente        siehe unten
	 * f Bytes          Grundeinstellung der n.Komponente
	 * </pre>
	 * Inhalt Byte : Anzeigeprinzip<br> Das Byte gibt das Anzeigeprinzip des adressierten/sendenden DEs an und ermöglicht
	 * damit die genaue Interpretation des folgenden Telegramminhalts. Es ist folgendermaßen codiert:<br>
	 * <pre>
	 * Anzeigeprinzip      Wert
	 *              a      0
	 *              b      1
	 *              c      2
	 *              d      3
	 *              e      4
	 *        Cluster      8
	 * </pre>
	 * Erhält ein DE in Abrufrichtung eine Nachricht mit einem Wert, der nicht seinem Anzeigeprinzip entspricht, so wird
	 * die Nachricht mit Code 21 "falsches Anzeigeprinzip" negativ quittiert.<br> Inhalt Byte: Stellcode der
	 * Grundeinstellung:<br> Der Inhalt des Bytes ist abhängig davon, ob das adressierte DE ein Clusterkanal ist bzw. vom
	 * Anzeigeprinzip des DEs. Diese Information ist in Byte 4 "Anzeigeprinzip" enthalten.<br>
	 * <pre>
	 * Clusterkanäle :   Nummer des Programms, das im Autarkbetrieb eingenommen werden soll. Ist der Wert 0,
	 *                   so nehmen alle DEs dann den Zustand ein, der ihrer jeweiligen individuellen
	 *                   Grundeinstellung entspricht. Ist der Wert 255, so behalten alle DEs den zuletzt eingestellten
	 *                   Zustand bei. Ist als Wert eine Programmnummer zwischen 1 und 254 angegeben, so werden
	 *                   alle DEs im Autarkbetrieb entsprechend der Definition dieses Programms eingestellt. Die
	 *                   Codedefinition wird für alle DEs übernommen und von diesen spontan gemeldet.
	 *                   Ausnahmen hiervon bilden lediglich DEs, für welche die entsprechende
	 *                   Programmdefinition den Wert 255 don´t care enthält. Diese DEs nehmen im
	 *                   Autarkbetrieb den Stellcode ihrer individuellen Grundeinstellung an.
	 * Anzeigeprinzip a und b :  WVZ-Code entsprechend Anhang 7, Kapitel 1. Gibt den WVZ-Code an, den das
	 *                           DE im Autarkbetrieb darstellen soll, falls die Grundeinstellungs-Programmnummer des
	 *                           Clusterkanals den Wert 0 enthält oder die Definition des Grundeinstellungsprogramms für
	 *                           dieses DE den Wert 255 "don´t care" angibt. In allen anderen Fällen ist die individuelle
	 *                           Grundeinstellung nicht relevant. Ist der Wert 255, so behält das WZG seinen letzten
	 *                           Stellzustand bei. Der Wert 0 ist für DEs dieser Anzeigeprinzipien nicht zulässig.
	 * Anzeigeprinzip c und d :  Stellcode des vordefinierten Textes, den das DE im Autarkbetrieb darstellen soll,
	 *                           falls die Grundeinstellungs-Programmnummer des Clusterkanals den Wert 0 enthält oder
	 *                           die Definition des Grundeinstellungsprogramms für dieses DE den Wert 255 "don´t care"
	 *                           angibt. In allen anderen Fällen ist die individuelle Grundeinstellung nicht relevant. Ist
	 * der
	 *                           Wert 255, so behält das WZG seinen zuletzt dargestellten Text bei. Ist der Wert hingegen
	 *                           0, so wird das Telegramm in der Langversion übertragen und enthält den darzustellenden
	 *                           Text als ASCII-String.
	 * Anzeigeprinzip e :        Stellcode der vordefinierten Gruppendefinition, die das DE im Autarkbetrieb
	 *                           darstellen soll, falls die Grundeinstellungs-Programmnummer des Clusterkanals den Wert 0
	 *                           enthält oder die Definition des Grundeinstellungsprogramms für dieses DE den Wert 255
	 *                           "don´t care" angibt. In allen anderen Fällen ist die individuelle Grundeinstellung nicht
	 *                           relevant. Ist der Wert 255, so behält die Gruppe ihren zuletzt dargestellten Inhalt bei.
	 * Ist der
	 *                           Wert hingegen 0, so wird das Telegramm in der Langversion übertragen und enthält für
	 *                           jede Komponente den entsprechenden Stellzustand.
	 * </pre>
	 * Zulässige Werte :
	 * <pre>
	 *                            Cluster                a,b               c,d,e
	 * Steuerungsprinzip 1        0, 255                 --                0, 255
	 * Steuerungsprinzip 2        1-254, 255             Anhang 7, Kap. 1  1-254,255
	 * Steuerungsprinzip 3        0,1-254,255            --                0,1-254,255
	 * </pre>
	 * Inhalt Funktionsbyte :<br> Der Inhalt des Funktionsbytes entspricht der verallgemeinerten Definition des
	 * Funktionsbytes in Kapitel 6.2.18.<br> <br> Inhalt Grundeinstellung einer Komponenten :<br> Dieser Teil des
	 * Telegramms wird genauso wie die Anzahl der Komponenten im Byte 7 nur in der Langversion des Telegramms übertragen,
	 * d.h. insbesondere, dass der Stellcode in Byte 5 den Wert 0 haben muss. Wird die Langversion mit einem Stellcode
	 * ungleich 0 empfangen, so wird mit Code 46 Langversion nicht zulässig negativ quittiert. Inhalt und Länge der
	 * wiederholten Komponentenblöcke sind abhängig vom Anzeigeprinzip des adressierten DE:<br>
	 * <pre>
	 * Clusterkanäle : Die Langversion ist für Clusterkanäle nicht zulässig. Die individuellen Grundeinstellungen
	 *                 werden an die einzelnen DEs direkt adressiert. Negative Quittung Code 46.
	 * Anzeigeprinzip a und b : Die Langversion ist inhaltsgemäß für diese Anzeigen nicht zulässig. Negative
	 *                 Quittung Code 46.
	 * Anzeigeprinzip c und d : Die Länge eines Komponentenblocks (f) ist 1, so dass die Langversion eine DEBlock-
	 *                 Länge von 6 + n hat. Die Anzahl Komponenten (Textzeichen) ist deswegen auf
	 *                 maximal 213 beschränkt. Jeder Komponentenblock ist folgendermaßen aufgebaut:
	 * <p/>
	 *                 Byte 1           Textzeichen in ASCII-Code        siehe Anhang 7, Kapitel 3
	 * <p/>
	 * Anzeigeprinzip e : Die Länge eines Komponentenblocks (f) ist 2, so dass die Langversion eine DE-Block-
	 *                 Länge von 6 + 2*n hat. Die Anzahl Komponenten ist deswegen auf maximal 106
	 *                 beschränkt. Jeder Komponentenblock ist folgendermaßen aufgebaut:
	 * <p/>
	 *                 Byte 1           WVZ-Code                         siehe Anhang 7, Kapitel 1
	 *                 Byte 2           Funktionsbyte
	 * <p/>
	 *                 Der Inhalt des Funktionsbytes entspricht der verallgemeinerten Definition des
	 *                 Funktionsbytes in Kapitel 6.2.18.
	 * </pre>
	 * Die folgende Tabelle stellt übersichtlich alle Varianten des Telegramms zusammen, erläutert deren Funktion und gibt
	 * an, für welche Kombination aus Anzeige- und Steuerungsprinzip die jeweilige Verwendung zulässig ist. Dabei sind
	 * Felder mit --  hinterlegt, wenn sie im betreffenden Kontext nicht relevant sind. Mit - hinterlegte Felder in der
	 * Spalte "Steuerungsprinzip" bedeuten, dass die jeweiligen Stellbefehle negativ quittiert werden, die Nummer in
	 * Klammern gibt den zu verwendenden Fehlercode an. Felder mit einem (zul) kennzeichnen die Zulässigkeit des
	 * entsprechenden Telegramms für das jeweilige DE. Eine hinter zul angefügte Nummer gekennzeichnetes Feld verweist auf
	 * einen Telegrammtyp aus früheren Versionen der TLS, die bei Altlagen im jeweiligen Kontext noch zulässig sind.<br>
	 * <pre>
	 * Steuerungsprinzip
	 * ID   Typ   Länge  Stellcode  n      Funktion                       Anzeige      f     Steuerungsprinzip
	 *                                                                    prinzip
	 *                                                                                       1        2       3
	 * 3R   33    5      0          --     Grundeinstellung pro DE        a,b          --    --       -(43)   --
	 *                              --     individuell festlegen          c-e          --    -(44)    -(43)   -(44)
	 *                              --                                    Cl           --    zul      -(43)   zul
	 *                   1-254      --     Grundeinstellung festlegen     a,b          --    --       zul 32  --
	 *                              --     mit Codenummer                 c,d          --    -(45)    zul     zul
	 *                              --                                    e,Cl         --    -(45)    zul 42  zul 42
	 *                   255        --     Grundeinstellung "son't care"  alle         --    zul      zul 42  zul 42
	 *            6+n*f  0          1 --   Grundeinstellung festlegen     a,b          --    --       -(43)   --
	 *                              1 213  mit freier Definition          c,d          1     zul      -(43)   zul
	 *                              1 106                                 e            2     zul      -(43)   zul
	 *                              1 --                                  Cl           --    --       -(43)   --
	 * 3R         5      0          --     Grundeinstellung pro DE        a,b          --    --       --      --
	 *                              --     individuell festlegen          Cl           --    zul      --      zul
	 *                   1-254      --     Grundeinstellung melden        a,b          --    --       zul 32  --
	 *                              --     mit Codenummer                 c,d          --    --       zul     zul
	 *                              --                                    e,Cl         --    --       zul 42  zul 42
	 *                   255        --     Grundeinstellung "son't care"  alle         --    zul      zul 42  zul 42
	 *            6+n*f  0          1 --   Grundeinstellung melden        a,b          --    --       --   --
	 *                              1 213  mit freier Definition          c,d          1     zul      --      zul
	 *                              1 106                                 e            2     zul      --      zul
	 *                              1 --                                  Cl           --    --       --      --
	 * 19R        2      --         --     Abruf Grundeinstellung         alle         --    zul      zul     zul
	 * </pre>
	 */

	void Fg004Typ033Id003Id031() {

	}

	/** FG 4 : Typ: 36 Id:   Name: Geographische Kenndaten. */

	void Fg004Typ036Id000() {

	}

	/**
	 * FG 4 : Typ: 42 Id: 3 Name: Grundprogramm (Abruf / Antwort).
	 * <p/>
	 * <p/>
	 * <pre>
	 * Position         Bezeichnung                             Erläuterung
	 * Byte 1           Länge DE-Block                          [ 3 ]
	 * Byte 2           Daten-Endgeräte-Kanal (DE)              [ 193..222, 223, (255), (evtl. 1..254,255)1 ]
	 * Byte 3           Typ der DE-Daten                        [ 42 ]
	 * Byte 4           Grundprogramm-Nummer                    [ 1 - 254, 255 ]
	 * 1) es wird der Clusterkanal gemäß der Definition Seite A6.1.1  3, Kapitel 1.4 angewendet, lediglich bei Anlagen,
	 * die
	 * nach dem Prinzip der alten FG5 (TLS Ausgabe 1993) arbeiten, können die E/A-Kanäle direkt adressiert werden
	 * </pre>
	 * Inhalt Byte Programm-Nummer:<br> Nummer des Programms, in das bei Autarkbetrieb umgeschaltet werden soll. Wird die
	 * Programmnummer 255 ausgewählt, so bleibt das vor Beginn des Autarkbetrieb geschaltete Programm im Autarkbetrieb
	 * bestehen.<br>
	 */

	void Fg004Typ042Id003() {

	}

	/**
	 * FG 4 : Typ: 43 Id: 3 Name: Codeliste (Antwort).
	 * <p/>
	 * <p/>
	 * <pre>
	 * Position         Bezeichnung                                    Erläuterung
	 * Byte 1           Länge DE-Block                                 Länge des folgenden DE-Blocks [ 4 + n ]
	 * Byte 2           Daten-Endgeräte-Kanal                          [ 1..254, 255 ]
	 * Byte 3           Typ der DE-Daten                               [ 43 ]
	 * Byte 4           Anzeigeprinzip                                 siehe unten
	 * Byte 5           Anzahl Codes = n                               [ 0..224 ]
	 * Byte 6           1. Stellcode                                   [ 1..254 ]
	 * Byte ..          n. Stellcode                                   [ 1..254 ]
	 * </pre>
	 * Inhalt Byte Anzeigeprinzip<br> Das Byte gibt das Anzeigeprinzip des sendenden DEs an und ermöglicht damit die genaue
	 * Interpretation des folgenden Telegramminhalts. Es ist folgendermaßen codiert:<br>
	 * <pre>
	 * Anzeigeprinzip        Wert
	 *              a        0
	 *              b        1
	 *              c        2
	 *              d        3
	 *              e        4
	 *        Cluster        8
	 * </pre>
	 * Inhalt Byte Anzahl Codes<br> Das Byte gibt die Anzahl der am DE oder am Clusterkanal aktuell definierten Stellcodes
	 * an.<br> <br> Inhalt Byte n. Stellcode<br> Je nach Anzeigeprinzip des DEs geben die Bytes verfügbare WVZ-Codes
	 * (Anzeigeprinzip a und b), Stellcodes vordefinierter Texte (Anzeigeprinzip c und d) und Gruppeneinstellungen
	 * (Anzeigeprinzip e) oder Programmnummern vordefinierter Programme (bei Clusterkanälen) an.<br>
	 */

	void Fg004Typ043Id003() {

	}

	/**
	 * FG 4 : Typ: 44 Id: 3 Name: Codedefinition (Abruf / Antwort).
	 * <p/>
	 * <p/>
	 * <pre>
	 * Position         Bezeichnung                                    Erläuterung
	 * Byte 1           Länge DE-Block                                 Länge des folgenden DE-Blocks [5+f*n]
	 * Byte 2           Daten-Endgeräte-Kanal (DE)                     [ 1..254 ]
	 * Byte 3           Typ der DE-Daten                               [ 44 ]
	 * Byte 4           Anzeigeprinzip                                 siehe unten
	 * Byte 5           Stellcode                                      [1..254, 255]siehe unten
	 * Byte 6           n : Anzahl Komponenten                         0, 1 - [213 | 106 | 53] siehe unten
	 * f Bytes...       Definition der 1.Komponente                    siehe unten
	 * f Bytes          Definition der n.Komponente
	 * </pre>
	 * Inhalt Byte : Anzeigeprinzip<br> Das Byte gibt das Anzeigeprinzip des adressierten/sendenden DEs an und ermöglicht
	 * damit die genaue Interpretation des folgenden Telegramminhalts. Es ist folgendermaßen codiert:<br>
	 * <pre>
	 * Anzeigeprinzip        Wert
	 *              a        0
	 *              b        1
	 *              c        2
	 *              d        3
	 *              e        4
	 *        Cluster        8
	 * </pre>
	 * Erhält ein DE in Abrufrichtung eine Nachricht mit einem Wert, der nicht seinem Anzeigeprinzip entspricht, so wird
	 * die Nachricht mit Code 21 "falsches Anzeigeprinzip" negativ quittiert.<br> <br> Inhalt Byte: Stellcode:<br> Gibt den
	 * Stellcode an, dessen Definition neu angelegt, geändert oder gelöscht werden soll. Der Wert 255 ist nur gültig im
	 * Zusammenhang mit einer Anzahl Komponenten von 0. In diesem Fall dient die Nachricht zum Löschen aller Definitionen
	 * aus dem Speicher des Gerätes, andernfalls wird mit Code 43 "unzulässiger Stellcode" negativ quittiert.<br> <br>
	 * Inhalt Byte : Anzahl Komponenten:<br> Für WZG vom Anzeigetyp a) ist das Telegramm nicht zulässig. Die Nachricht wird
	 * von solchen DEs mit Code 41 "Stellcodevorrat nicht änderbar" negativ quittiert.<br> Für WZG vom Anzeigeprinzip b)
	 * gibt das Byte in Antwortrichtung als Antwort auf Abruf mit Typ 21 optional die Anzahl der an der Darstellung des
	 * erfragten WVZ-Codes beteiligten Lampen an. In Abrufrichtung ist das Telegramm für WZG vom Anzeigeprinzip b) nicht
	 * zulässig und wird ebenfalls mit Code 41 negativ quittiert.<br> Für WZG vom Anzeigeprinzip c) und d) (Wechseltext)
	 * gibt das Byte die Länge des folgenden Textes an. Die Angabe der Textlänge ist unabhängig von der Anzahl der
	 * tatsächlich vorhandenen Textzeichen. Wenn eine geringere Anzahl Zeichen übergeben wird, wird der Rest ausgeschaltet.
	 * Wird eine größere Anzahl übergeben, wird der Befehl mit Code 19 "Wechseltext nicht darstellbar, da zu lang" negativ
	 * quittiert.<br> Für WZG vom Anzeigeprinzip e) (Gruppen) gibt das Byte die Anzahl der Anzeigen/Prismen dieses DEs an.
	 * Als Zuweisung sind nur DE-Blöcke zulässig, die genau für jede/jedes an diesem DE vorhandene Anzeige/Prisma eine
	 * Definition enthalten. Andere DE-Blöcke werden mit Code 17 negativ quittiert.<br> Für Clusterkanäle gibt das Byte die
	 * Anzahl der DEs der FG 4 an diesem EAK an. Als Zuweisung sind nur DEBlöcke zulässig, die genau für jedes an diesem
	 * EAK vorhandene DE eine Definition enthalten. Andere DEBlöcke werden mit Code 17 negativ quittiert.<br> Der Wert 0
	 * ist zulässig für WZGs c)-e) und Cluster, um Definitionen von Stellcodes zu löschen, wenn dies nicht generell
	 * ausgeschlossen wurde (Anhang 9), ansonsten werden solche Nachrichten mit Code 41 "Stellcode-Vorrat nicht änderbar"
	 * negativ quittiert.<br> <br> Inhalt : Definition einer Komponente:<br> Für WZG vom Anzeigeprinzip a) und b) (feste
	 * Zeicheninhalte) ist das Telegramm in Abrufrichtung nicht zulässig. Für aktiv leuchtende WZG kann das Telegramm in
	 * Antwortrichtung (auf Abruf mit Typ 21) allerdings optional dazu genutzt werden, der Zentrale die an der Darstellung
	 * eines WVZ beteiligten Lampen zu benennen. Mit dieser Information kann die Zentrale die oft geforderte Überwachung
	 * von Lampenbrenndauern implementieren, ohne die Zuordnung von Lampen zu Zeicheninhalten separat parametrieren zu
	 * müssen. Die Definition einer Komponente hat dann je ein Byte und ist wie folgt aufgebaut:<br>
	 * <pre>
	 * Byte 1           Nummer der beteiligten Lampe          Nummerierung wie bei Typ 3
	 * </pre>
	 * Für WZG vom Anzeigeprinzip c) und d) (Wechseltext) besteht die Definition einer Komponente aus jeweils nur einem
	 * Byte und ist wie folgt aufgebaut :<br>
	 * <pre>
	 * Byte 1           Textzeichen in ASCII-Code             siehe Anhang 7, Kapitel 3
	 * </pre>
	 * Für WZG vom Anzeigeprinzip e) (Gruppen) besteht die Definition einer Komponente aus jeweils 2 Bytes und ist wie
	 * folgt aufgebaut:<br>
	 * <pre>
	 * Byte 1           WVZ-Code                              siehe Anhang 7, Kapitel 1
	 * Byte 2           Funktionsbyte                         siehe Definition in Kapitel 6.2.18
	 * </pre>
	 * Der Inhalt des Funktionsbytes entspricht der verallgemeinerten Definition des Funktionsbytes in Kapitel 6.2.18.<br>
	 * Für Clusterkanäle besteht die Definition einer Komponente aus jeweils 4 Bytes. Jedes DE der FG4 an dem EAK bildet
	 * dabei eine Komponente. (Es ist darauf zu achten, dass sich für EAKs, die im Programmmodus gesteuert werden können,
	 * die Anzahl der maximal zulässigen DEs auf 53 reduziert gegenüber den 56 per DEKonfiguration möglichen). Der Aufbau
	 * ist wie folgt:<br>
	 * <pre>
	 * Byte 1           DE-Nummer der Komponente
	 * Byte 2           Anzeigeprinzip dieses DEs              siehe unten
	 * Byte 3           Stellcode für die Komponente           siehe Anhang 7, Kapitel 1 bzw. [ 1  254, 255 ]
	 * Byte 4           Funktionsbyte                          siehe Definition in Kapitel 6.2.18
	 * </pre>
	 * Das Byte 2 codiert das Anzeigeprinzip des DEs und ermöglicht so eine eindeutige Interpretation der folgenden
	 * Definitionskomponente. Es werden die gleiche Wert wie oben verwendet, nur der Wert 8 für Clusterkanäle ist hier
	 * natürlich nicht zulässig.<br> Das Byte 3 hat dabei die jedem DE entsprechende Bedeutung entweder als WVZ-Code oder
	 * als Stellcode einer Text- oder einer Gruppendefinition. Hier ist auch der Wert 255 zulässig, er bedeutet unabhängig
	 * vom Anzeigeprinzip des DEs, dass dieses DE individuell angesteuert werden kann, auch wenn der Cluster im
	 * Programmmodus gesteuert wird.<br> Der Inhalt des Funktionsbytes entspricht der verallgemeinerten Definition des
	 * Funktionsbytes in Kapitel 6.2.18.<br>
	 * <pre>
	 * Hinweis :    Es wird empfohlen, die Definition der Codes im EAK intern E/A-kanalbezogen abzulegen, um zu
	 *              verhindern, dass bei geänderter DE-Zuordnung alle Programmdefinitionen gelöscht werden
	 *              müssen. Ansonsten, oder wenn die projektierten E/A-Kanäle nicht gleichgeblieben sind, werden
	 *              bei Zuweisung einer geänderten DE-Zuordnung über die Nachricht Typ 33 der
	 *              Funktionsgruppe 254 alle Programmdefinitionen für die betroffenen EAKs gelöscht. Der
	 *              Clusterkanal meldet dann spontan mit Typ 43, dass für ihn jetzt keine Programme mehr definiert
	 *              sind. Enthält die Zuweisung der DE-Zuordnung allerdings bzgl. der vorigen Zuordnungstabelle
	 *              nur Änderungen der DE-Nummern einer gleichbleibenden Menge von E/A-Kanälen oder nur
	 *              Änderungen bzgl. anderer EAKs, so bleiben die Programm-Definitionen erhalten.
	 * </pre>
	 * Es ist dabei zu beachten, dass die Stellcodes der einzelnen DEs nach Anzeigeprinzip c)-e) genauso wie trivialerweise
	 * die WVZ-Codes für Anzeigen vom Prinzip a) oder b) von den Programmnummern des EAKs vollständig unabhängig sind.<br>
	 * <br> Erhält ein DE ein Telegramm, dessen Länge nicht den obigen Festlegungen entspricht, so wird die Nachricht
	 * negativ quittiert.<br> Die folgende Tabelle stellt übersichtlich alle Varianten des Telegramms zusammen, erläutert
	 * deren Funktion und gibt an, für welche Kombination aus Anzeige- und Steuerungsprinzip die jeweilige Verwendung
	 * zulässig ist. Dabei sind Felder mit --  hinterlegt, wenn sie im betreffenden Kontext nicht relevant sind. Mit -
	 * hinterlegte Felder in der Spalte "Steuerungsprinzip" bedeuten, dass die jeweiligen Stellbefehle negativ quittiert
	 * werden, die Nummer in Klammern gibt den zu verwendenden Fehlercode an. Felder mit einem (zul) kennzeichnen die
	 * Zulässigkeit des entsprechenden Telegramms für das jeweilige DE.<br>
	 * <pre>
	 * ID   Typ   Länge  Stellcode  n      Funktion                       Anzeige      f     Steuerungsprinzip
	 *                                                                    prinzip
	 *                                                                                       1        2       3
	 * 3R   44    5+n*f  1-254      0      Code-Definition löschen        a,b          --    --       -(41)   --
	 *                                                                    c-e, Cl      --    -(45)    zul     zul
	 * <p/>
	 *                              1 --   Code-Definition anlegen        a,b          --    --       -(41)    --
	 *                              1 213  oder ändern                    c,d          1     -(45)    zul     zul
	 *                              1 106                                 e            2     -(45)    zul     zul
	 *                              1  53                                 Cl           4     -(45)    zul     zul
	 *                   255        0      Alle Code-Definitionen         a,b          --    --       -(41)   --
	 *                                     löschen                        c.e, Cl      --    -(45)    zul     zul
	 * 3A                1-254      0      Meldung Code gelöscht          a,b          --    --       --      --
	 *                                     (nicht auf Abfrage)            c-e, Cl      --    --       zul     zul
	 *                              1 --   --                             a            --    --       --      --
	 *                              1 213  Meldung beteiligter Lampen     b            1     --       zul     --
	 *                              1 213  Meldung Code-Definiton         c,d          1     --       zul     zul
	 *                              1 106                                 e            2     --       zul     zul
	 *                              1  53                                 Cl           4     --       zul     zul
	 *                   255        0      Meldung alle Codes gelöscht    a,b          --    --       --      --
	 *                                     (nicht auf Abfrage)            c.e, Cl      --    --       zul     zul
	 * </pre>
	 * Löschen und Ändern von Codedefinitionen<br> Löschen und Ändern nicht aktuell oder als Grundeinstellung verwendeter
	 * Codes des Clusterkanals ist zulässig und kann ohne weiteres durchgeführt werden. Löschen oder Ändern aktuell
	 * anstehender Codes führen dazu, dass der Clusterkanal in der Folge spontan vom Programmmodus in den Komponentenmodus
	 * übergeht und dies spontan mit einer Nachricht Typ 55 meldet. Damit bleibt der aktuelle Anzeigezustand erhalten.
	 * Entsprechendes gilt, wenn der geänderte oder gelöschte Code als Grundprogramm am Cluster definiert ist: In der Folge
	 * gilt für den Cluster, dass die Grundeinstellung im Komponentenmodus definiert ist. Der Cluster meldet dies spontan
	 * mit einer Nachricht vom Typ 33.<br> Ein Stellcode für ein einzelnes DE darf nicht gelöscht werden, solange er in der
	 * Definition eines oder mehrerer Programme seines Clusterkanals noch verwendet wird. Wenn der EAK feststellt, dass der
	 * zu löschende Stellcode noch in der Definition eines seiner Programme verwendet wird, so wird der Löschbefehl mit
	 * Code 47 "Löschen benutzter Stellcodes unzulässig" negativ quittiert.<br>
	 */

	void Fg004Typ044Id003() {

	}

	/**
	 * FG 4 : Typ: 48 Id: 5 und Id 37 Name: WVZ-Stellzustand (Abruf / Antwort).
	 * <p/>
	 * <p/>
	 * <pre>
	 * Position         Bezeichnung                             Erläuterung
	 * Byte 1           Länge DE-Block                          Länge des folgenden DE-Blocks [ 4 ]
	 * Byte 2           Daten-Endgeräte-Kanal (DE)              [ 1..254, 255 ]
	 * Byte 3           Typ der DE-Daten                        [ 48 ]
	 * Byte 4           Stellzustand: Code                      anzuzeigendes WVZ
	 * Byte 5           Funktionsbyte                           Ein / Aus / Blinken
	 * </pre>
	 * Inhalt Byte Stellzustand:<br> Codierung von Verkehrszeichen: (WVZ-Code): Siehe Anhang 7, Kapitel 1.<br> <br> Inhalt
	 * Funktionsbyte:
	 * <pre>
	 *    7        6        5        4        3        2        1        0
	 *               Blinkzeit                            Funktion
	 * Bit 0..3:     Funktion:
	 *               0 = ausschalten
	 *               1 = einschalten
	 *               2 = blinken (Die Einstellung "WVZ blinkend" ist eine optionale Eigenschaft.)
	 *               3-15 reserviert
	 * <p/>
	 * Bit 4..7:     Blinkzeit in 200 ms (1..3 s)
	 *               Die Blinkzeit ist die gesamte Periodendauer, d.h. die Summe aus Ein- und Auszeit. Das Verhältnis Ein-
	 *               /Auszeit wird nach Vorgabe des Anlagenbetreibers am WZG eingestellt.
	 *               Eine sinnvolle Abstimmung der Periodendauern für verschiedene WVZ ist Aufgabe der Zentrale.
	 * </pre>
	 */

	void Fg004Typ048Id005Id037() {

	}

	/**
	 * FG 4 : Typ: 49 Id: 5 und Id: 37 Name: Helligkeit (Abruf / Antwort).
	 * <p/>
	 * <p/>
	 * <pre>
	 * Position         Bezeichnung                                    Erläuterung
	 * Byte 1           Länge DE-Block                                 Länge des folgenden DE-Blocks [ 4 ]
	 * Byte 2           Daten-Endgeräte-Kanal (DE)                     [193..222, 223, (255)1 ]
	 * Byte 3           Typ der DE-Daten                               [ 49 ]
	 * Byte 4           Helligkeitswert                                [ 0..100 Prozent ]
	 * Byte 5           Helligkeitsstatusbyte                          siehe unten
	 * 1) siehe Anhang 6, Teil 1, Kapitel 1.4
	 * </pre>
	 * Inhalt Byte: Helligkeitswert:<br> Der Helligkeitswert für WZGs wird unabhängig von dem Anzeigeprinzip des WZG als
	 * eine Prozentzahl von 0 bis 100 übertragen. WZGs stellen die dem Prozentwert am nächsten liegende Helligkeitsstufe
	 * ein. Die hierbei geltenden lichttechnischen Anforderungen werden in den "vorläufigen lichttechnischen Festlegungen
	 * für WVZ und Fahrstreifensignalgeber nach dem Lichtrasterprinzip" der BASt beschrieben.<br> In Nachrichten in
	 * Abrufrichtung, die im Helligkeitsstatusbyte die automatische Helligkeitsteuerung einschalten, ist der
	 * Helligkeitswert nicht definiert.<br> <br> Inhalt Helligkeitsstatusbyte:<br>
	 * <pre>
	 *    7        6        5        4        3        2        1        0
	 *    X        X        X        X        X        X        Meld.    Autom.
	 * <p/>
	 * Bit 0:   Automatik:
	 *          0 = Helligkeitswert wird durch die Zentrale ferneingestellt
	 *          1 = automatische, lokale Helligkeitssteuerung (optional, s.o.)
	 * Bit 1:   Meldungen im Automatikbetrieb:
	 *          0 = keine spontanen Meldungen des aktuellen Helligkeitswertes
	 *          1 = nach jeder Änderung des eingestellten Helligkeitswertes spontane Meldung senden
	 * <pre>
	 */

	void Fg004Typ049Id005Id037() {

	}

	/**
	 * FG 4 : Typ: 50 Id: 5 und Id 37 Name: Wechseltext (Abruf / Antwort).
	 * <p/>
	 * <p/>
	 * <pre>
	 * Position         Bezeichnung                             Erläuterung
	 * Byte 1           Länge DE-Block                          Länge des folgenden DE-Blocks [ 4 + Textl. ]
	 * Byte 2           Daten-Endgeräte-Kanal (DE)              [ 1..254, 255 ]
	 * Byte 3           Typ der DE-Daten                        [ 50 ]
	 * Byte 4           Funktionsbyte                           Ein / Aus / Blinken
	 * Byte 5           Anzahl Textzeichen                      [ 0..220 ]
	 * Byte 6           1. Textzeichen in ASCII-Code            angezeigter / anzuzeigender Text
	 * Byte 7           2. Textzeichen in ASCII-Code            (siehe Anhang 7, Kap.3)
	 * ......
	 * Byte ..          n. Textzeichen in ASCII-Code
	 * </pre>
	 * Inhalt Funktionsbyte:<br> Codierung von Verkehrszeichen: (WVZ-Code): Siehe Anhang 7, Kapitel 1.<br>
	 * <pre>
	 *    7        6        5        4        3        2        1        0
	 *               Blinkzeit                            Funktion
	 * Bit 0..3:     Funktion:
	 *               0 = ausschalten
	 *               1 = einschalten
	 *               2 = blinken (Die Einstellung "WVZ blinkend" ist eine optionale Eigenschaft.)
	 *               3-15 reserviert
	 * <p/>
	 * Bit 4..7:     Blinkzeit in 200 ms (1..3 s)
	 *               Die Blinkzeit ist die gesamte Periodendauer, d.h. die Summe aus Ein- und Auszeit. Das Verhältnis Ein-
	 *               /Auszeit wird nach Vorgabe des Anlagenbetreibers am WZG eingestellt.
	 *               Eine sinnvolle Abstimmung der Periodendauern für verschiedene WVZ ist Aufgabe der Zentrale.
	 * </pre>
	 */

	void Fg004Typ050Id005Id037() {

	}

	/**
	 * FG 4 : Typ: 55Id: 5und Id: 37 Name: Stellzustand (Abruf / Antwort).
	 * <p/>
	 * <p/>
	 * <pre>
	 * Position         Bezeichnung                                    Erläuterung
	 * Byte 1           Länge DE-Block                                 [5 | 6+f*n]
	 * Byte 2           Daten-Endgeräte-Kanal (DE)                     [ 1..254 ]
	 * Byte 3           Typ der DE-Daten                               [ 55 ]
	 * Byte 4           Anzeigeprinzip                                 siehe unten
	 * Byte 5           Stellcode                                      anzuzeigendes WVZ/Programm
	 * Byte 6           Funktionsbyte                                  siehe unten
	 * Byte 7           n : Anzahl Komponenten                         1 -[213 | 106] siehe unten
	 * f Bytes...       Stellzustand der 1.Komponente                  siehe unten
	 * f Bytes          Stellzustand der n.Komponente
	 * </pre>
	 * Inhalt Byte : Anzeigeprinzip<br> Das Byte gibt das Anzeigeprinzip des adressierten/sendenden DEs an und ermöglicht
	 * damit die genaue Interpretation des folgenden Telegramminhalts. Es ist folgendermaßen codiert:<br>
	 * <pre>
	 * Anzeigeprinzip        Wert
	 *              a        0
	 *              b        1
	 *              c        2
	 *              d        3
	 *              e        4
	 *        Cluster        8
	 * </pre>
	 * Erhält ein DE in Abrufrichtung eine Nachricht mit einem Wert, der nicht seinem Anzeigeprinzip entspricht, so wird
	 * die Nachricht mit Code 21 falsches Anzeigeprinzip negativ quittiert.<br> <br> Inhalt Byte: Stellcode<br> Der
	 * Inhalt des Bytes ist abhängig davon, ob das adressierte DE ein Clusterkanal ist bzw. vom Anzeigeprinzip des
	 * DEs:<br>
	 * <pre>
	 * Clusterkanäle :   Nummer des Programms, das eingestellt werden soll. Ist der Wert 0, so behalten alle DEs
	 *                   den Zustand , den sie zuletzt hatten. In der Folge akzeptieren diese DEs individuell an sie
	 *                   gerichtete Stellbefehle und ändern ihren Zustand entsprechend. Ist als Wert eine
	 *                   Programmnummer zwischen 1 und 254 angegeben, so werden alle DEs entsprechend der
	 *                   Definition dieses Programms eingestellt. Ausnahmen hiervon bilden lediglich DEs, für
	 *                   welche die entsprechende Programmdefinition der Wert 255 "don´t care" enthält. Diese
	 *                   DEs behalten ihren Zustand und sind in der Folge durch individuelle Stellbefehle steuerbar.
	 *                   Der Wert 255 ist nicht zulässig und wird mit Code 43 negativ quittiert.
	 * Anzeigeprinzip a und b :   WVZ-Code entsprechend Anhang 7, Kapitel 1. Gibt den WVZ-Code an, den das
	 *                   DE darstellen soll. Die Nachricht wird nur akzeptiert, wenn der Stellcode des Clusterkanals
	 *                   den Wert 0 enthält oder die Definition des am Cluster eingestellten Programms für dieses
	 *                   DE den Wert 255 "don´t care" angibt. In allen anderen Fällen wird der Stellbefehl mit Code
	 *                   10 "Befehl bzw. Programm in dieser Betriebsart nicht ausführbar" negativ quittiert. Der
	 *                   Wert 0 ist für DEs dieser Anzeigeprinzipien nicht zulässig und wird ebenfalls negativ
	 *                   quittiert.
	 * Anzeigeprinzip c und d :   Stellcode des vordefinierten Textes, den das DE darstellen soll. Die Nachricht
	 *                   wird nur akzeptiert, wenn der eingestellte Stellcode des Clusterkanals den Wert 0 enthält
	 *                   oder die Definition des am Cluster eingestellten Programms für dieses DE den Wert 255
	 *                   "don´t care" angibt. In allen anderen Fällen wird der Stellbefehl mit Code 10 "Befehl bzw.
	 *                   Programm in dieser Betriebsart nicht ausführbar" negativ quittiert. Ist der Wert 0, so wird
	 *                   das Telegramm in der Langversion übertragen und enthält den darzustellenden Text als
	 *                   ASCII-String.
	 * Anzeigeprinzip e :   Stellcode der vordefinierten Gruppendefinition, die das DE darstellen soll. Die
	 *                   Nachricht wird nur akzeptiert, wenn der eingestellte Stellcode des Clusterkanals den Wert 0
	 *                   enthält oder die Definition des am Cluster eingestellten Programms für dieses DE den Wert
	 *                   255 "don´t care" angibt. In allen anderen Fällen wird der Stellbefehl mit Code 10 "Befehl
	 *                   bzw. Programm in dieser Betriebsart nicht ausführbar" negativ quittiert. Ist der Wert 0, so
	 *                   wird das Telegramm in der Langversion übertragen und enthält für jede Komponente den
	 *                   entsprechenden Stellzustand.
	 * </pre>
	 * Zulässige Werte:
	 * <pre>
	 *                       Cluster                      a,b                      c,d,e
	 * Steuerungsprinzip 1   0                            --                       0
	 * Steuerungsprinzip 2   1-254                        Anhang 7, Kap. 1         1-254
	 * Steuerungsprinzip 3   0,1-254                      --                       0,1-254
	 * </pre>
	 * Inhalt Funktionsbyte:<br>
	 * <pre>
	 *    7        6        5        4        3        2        1        0
	 *               Blinkzeit                      Status       Funktion
	 * </pre>
	 * Funktion
	 * <pre>
	 * Bit    Wert   Bedeutung                           Kommentar
	 * 0..1   0      ausschalten                         nur für DEs nach Anzeigeprinzip b und d
	 *        1      einschalten                         sowie Blinker nach Anzeigeprinzip a
	 *        2      blinken                             nur bei DEs nach Anzeigeprinzip b und d, optional
	 *        3      reserviert
	 * DEs, die in Abrufrichtung ein Funktionsbyte mit einem Wert erhalten, der gemäß ihrem Anzeigeprinzip
	 * nicht zulässig ist, antworten mit einer negativen Quittung, Code 14 "Funktionsbyte unzulässig".
	 * </pre>
	 * Status (nur in Antwortrichtung):
	 * <pre>
	 * Bit    Wert   Bedeutung                           Kommentar
	 * 2      0      kein Fehler aufgetreten
	 *        1      Fehler aufgetreten
	 * 3      2      Programm abgeschlossen              wird nur verwendet von Clusterkanälen und DEs, die
	 *        3      Programm noch nicht abgeschlossen   Programmschaltungen ausführen
	 * Blinkzeit<br>
	 * <pre>
	 * Bit    Wert   Bedeutung                           Kommentar
	 * 4..7   5-15   Blinkzeit in 200ms (1..3 s)         nur für DEs nach Anzeigeprinzip b und d
	 *        0                                          wenn Funktion ungleich "blinken"
	 * Die Blinkzeit ist die gesamte Periodendauer, d.h. die Summe aus Ein- und Auszeit. Das Verhältnis Ein-
	 * /Auszeit wird nach Vorgabe des Anlagenbetreibers am WZG eingestellt.
	 * Eine sinnvolle Abstimmung der Periodendauern für verschiedene WVZ ist Aufgabe der Zentrale.
	 * </pre>
	 * Inhalt Anzahl Komponenten :
	 * Wird die Nachricht in der Langversion versendet (nur bei Stellcode gleich 0), so gibt das Byte die Anzahl der
	 * Komponenten an, für die in der Folge Stellzustände übermittelt werden.
	 * Die Langversion ist nur für WZG nach Anzeigeprinzip c)-e) zulässig, für Anzeigen nach Prinzip a) und b) ist
	 * sie nicht anwendbar und für Clusterkanäle werden individuelle Stellbefehle an die jeweiligen DEs direkt
	 * adressiert.
	 * Inhalt : Stellzustand einer Komponente:
	 * Für WZG vom Anzeigeprinzip a) und b) (feste Zeicheninhalte) ist das Telegramm in der Langversion nicht
	 * zulässig, da es bedeutungslos wäre.
	 * Für WZG vom Anzeigeprinzip c) und d) (Wechseltext) besteht der Stellzustand einer Komponente aus jeweils
	 * nur einem Byte und ist wie folgt aufgebaut :
	 * <pre>
	 * Byte 1            Textzeichen in ASCII-Code            siehe Anhang 7, Kapitel 3
	 * </pre>
	 * Für WZG vom Anzeigeprinzip e) (Gruppen) besteht der Stellzustand einer Komponente aus jeweils 2 Bytes
	 * und ist wie folgt aufgebaut:<br>
	 * <pre>
	 * Byte 1            WVZ-Code                             siehe Anhang 7, Kapitel 1
	 * Byte 2            Funktionsbyte                        siehe oben
	 * </pre>
	 * Das Funktionsbyte ist definiert wie oben. Komponenten nach Anzeigeprinzip a) melden in Antwortrichtung
	 * den Sachverhalt Störung erkannt - Prisma nicht bewegbar / Blinker defekt mit gesetztem Bit 2 im
	 * Funktionsbyte. Kann der eingestellte WVZ-Code vom Gerät noch ermittelt werden, so wird er in Byte 1
	 * übertragen. Ansonsten wird der WVZ-Code 245 undefinierte Stellung gemeldet.
	 * Für Clusterkanäle ist die Nachricht in der Langversion nicht zulässig, da die Stellbefehle an die einzelnen DEs
	 * direkt adressiert werden können.<br>
	 * <br>
	 * Die folgende Tabelle stellt übersichtlich alle Varianten des Telegramms zusammen, erläutert deren Funktion und gibt
	 * an, für welche Kombination aus Anzeige und Steuerungsprinzip die jeweilige Verwendung zulässig ist. Dabei sind
	 * Felder -- gekennzeichnet, wenn sie im betreffenden Kontext nicht relevant sind. Mit - gekennzeichnete Felder in der
	 * Spalte "Steuerungsprinzip" bedeuten, dass die jeweiligen Stellbefehle negativ quittiert werden, die Nummer in
	 * Klammern gibt den zu verwendenden Fehlercode an. Felder mit zul kennzeichnen die Zulässigkeit des
	 * entsprechenden Telegramms für das jeweilige DE. Eine hinter zul angefügte Nummer  verweist auf
	 * einen Telegrammtyp aus früheren Versionen der TLS, die bei Altlagen im jeweiligen Kontext noch zulässig sind.<br>
	 * <pre>
	 * ID   Typ   Länge  Stellcode  n      Funktion                       Anzeige      f     Steuerungsprinzip
	 *                                                                    prinzip
	 *                                                                                       1        2       3
	 * 5R   55    5      1-254      --     Stellbefehl mit Codenummer     a            --    --       zul     --
	 *                              --                                    b            --    --       zul 48  --
	 *                              --                                    c,d,Cl       --    -(45)    zul     zul
	 *                              --                                    e            --    -(45)    zul 58  zul 58
	 *                   0          --     Stellbefehl mit freier         a-e          --    -(44)    -(43)   -(44)
	 *                              --     Definition                     Cl           --    zul      -(43)   zul
	 *            6+n*f  0          1 --   Stellbefehl mit freier         a,b          --    --       -(46)   --
	 *                              1 213  Definition                     c,d          1     zul 50   -(46)   zul 50
	 *                              1 106                                 e            2     zul      -(46)   zul
	 *                              1 --                                  Cl           --    -(46)    -(46)   -(46)
	 * 5A         5      1-254      --     Stellzustand mit Codenummer    a            --    --       zul     --
	 *                              --                                    b            --    --       zul 48  --
	 *                              --                                    c,d,Cl       --    --       zul     zul
	 *                              --                                    e            --    --       zul 58  zul 58
	 *                   0          --     Stellzustand mit freier        a-e          --    --       --      --
	 *                              --     Definition                     Cl           --    --       zul     zul
	 *            6+n*f  0          1 --   Stellzustand mit freier        a,b          --    --       --      --
	 *                              1 213  Definition                     c,d          1     zul 50   --      zul 50
	 *                              1 106                                 e            2     zul      --      zul
	 *                              1 --                                  Cl           --    --       --      --
	 * 21R        2      --         --     Abruf Stellzustand             alle         --    zul      zul     zul
	 * </pre>
	 */

	void Fg004Typ055Id005Id037() {

	}

	/**
	 * FG 4 : Typ: 58 Id: 5 und Id 37 Name: Wechseltext (Abruf / Antwort).
	 * <p/>
	 * <p/>
	 * <pre>
	 * Position         Bezeichnung                             Erläuterung
	 * Byte 1           Länge DE-Block                          [ 4 ]
	 * Byte 2           Daten-Endgeräte-Kanal (DE)              [ 193..222, 223, (255), (evt. 1..254, 255)1 ]
	 * Byte 3           Typ der DE-Daten                        [ 58 ]
	 * Byte 4           Programm-Nummer                         [ 1 - 254, 255 ]
	 * Byte 5           Programmstatus                          [ siehe unten ]
	 * 1) es wird der Clusterkanal gemäß der Definition Seite A6.1.1  3, Kapitel 1.4 angewendet, lediglich bei , die nach
	 * dem Prinzip der alten FG5 (TLS Ausgabe 1993) arbeiten, können die E/A-Kanäle direkt adressiert werden
	 * </pre>
	 * Inhalt Byte Programm-Nummer:<br> Programm-Nummer des projektierten Programms in das umgeschaltet werden soll. Die
	 * Verwendung der Programmnummer 255 wird in Anhang 6, Teil 1 Kapitel 3.5.5 und 3.5.6 erläutert<br> Inhalt Byte
	 * Programmstatus:<br>
	 * <pre>
	 *    7        6        5        4        3        2        1        0
	 *                       reserviert                           Status
	 * Status
	 * Bit 0:        0 = Programm abgeschlossen
	 *               1 = Programm noch nicht abgeschlossen
	 * Bit 1:        0 = kein Fehler aufgetreten
	 *               1 = Fehler aufgetreten
	 * In Stellbefehlen (Abrufrichtung) ist das Byte funktionslos und wird mit 0 belegt.
	 * </pre>
	 */

	void Fg004Typ058Id005Id037() {

	}
}